#include <iostream>
#include <list>
#include <algorithm>
using namespace std;

int main()
{
    list<int> liste;

    /* Elemente 1 bis 9 in die Liste einfuegen
     */
    for (int i=1; i<=9; i++) {
        liste.push_back(i);
    }

    /* aktuelles letztes Element merken
     *  - beachte: Ende merken geht nicht, da das Ende
     *             mit nach hinten wandert
     */
    list<int>::iterator pos;
    pos = liste.end();
    advance(pos,-1);

    /* Elemente 2 bis 9 an die Liste anhaengen
     */
    for (int i=2; i<=9; i++) {
        liste.push_back(i);
    }

    /* Teilmengen und Gesamtmenge ausgeben
     *  - kann last1 wieder auf das erste Element
     *    der zweiten Teilmenge gesetzt werden
     */
    advance (pos,1);
    copy (liste.begin(), pos,
          ostream_iterator<int>(cout," "));
    cout << endl;
    copy (pos, liste.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
    copy (liste.begin(), liste.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Gesamtmenge sortieren
     */
    inplace_merge (liste.begin(), pos, liste.end());

    /* Gesamtmenge wieder ausgeben
     */
    copy (liste.begin(), liste.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
