#include <iostream>
#include <vector>
#include <list>
#include <algorithm>
#include <functional>
#include "PRINT.h"
using namespace std;

int main()
{
    vector<int> menge1;
    list<int> menge2;

    /* Elemente 1 bis 9 in die erste Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge1.push_back(i);    // aufsteigend
    }
    PRINT ("menge1:    ", menge1);

    /* Elemente in der Menge quadrieren
     *  - mit sich selbst multiplizieren
     *  - frueher "times" statt "multiplies"
     */
    transform (menge1.begin(), menge1.end(),  // erster Quellbereich
               menge1.begin(),                // zweiter Quellbereich
               menge1.begin(),                // Zielbereich
               multiplies<int>());            // Operation
    PRINT ("quadriert: ", menge1);

    /* Elemente aufsteigend mit den Elementen absteigend addieren
     * und in zweite Menge eintragen
     */
    transform (menge1.begin(), menge1.end(),  // erster Quellbereich
               menge1.rbegin(),               // zweiter Quellbereich
               back_inserter(menge2),         // Zielbereich
               plus<int>());                  // Operation
    PRINT ("addiert:   ", menge2);

    /* Differenz von jeweils zwei Elementen beider Mengen ausgeben
     */
    transform (menge1.begin(), menge1.end(),
               menge2.begin(),
               ostream_iterator<int>(cout, " "),
               minus<int>());
    cout << endl;
}
