#include <sstream>
#include <bitset>
using namespace std;

int main()
{
    ostringstream os;

    // Dezimal- und Hexadezimal-Wert
    os << "Dec: " << 15 << hex << " Hex: " << 15 << endl;
    cout << os.str() << endl;

    // Gleitkommawert und Bitfeld anhaengen
    bitset<15> b(5789);
    os << "Float: " << 4.67 << " Bitset: " << b << endl;
    cout << os.str() << endl;

    // Oktal-Wert
    os.seekp(0);
    os << "Oct: " << oct << 15;
    cout << '"' << os.str() << '"' << endl;
}
