#include <iostream>
#include <map>
#include <string>
using namespace std;

int main()
{
    /* Datentyp des Containers
     *  - map: Wertepaare
     *  - string: mit strings als Schluessel
     *  - float: mit floats als Werte dazu
     *  - greater: absteigend sortiert
     */
    typedef map<string,float,greater<string> > StringFloatMap;

    StringFloatMap menge;

    /* einige Elemente in die Menge einfuegen
     */
    menge["Mehrwertsteuer"] = 0.15;
    menge["Pi"] = 3.1415;
    menge["irgend 'ne Zahl"] = 4983.223;
    menge["Null"] = 0;

    /* Iterator ueber alle Elemente wandern lassen
     * und aktuelles Element jeweils ausgeben
     */
    StringFloatMap::iterator pos;
    for (pos = menge.begin(); pos != menge.end(); ++pos) {
        cout << "Key: \"" << pos->first << "\" "
             << "Value: " << pos->second << endl;
    }
}
