#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
using namespace std;

int main()
{
    vector<int> menge;

    /* Elemente 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_back(i);
    }

    /* Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Elemente aufsummieren
     */
    cout << "Summe: "
         << accumulate (menge.begin(), menge.end(), 0) << endl;

    /* Elemente aufsummieren und 100 abziehen
     */
    cout << "Summe-100: "
         << accumulate (menge.begin(), menge.end(), -100) << endl;

    /* Elemente ausmultiplizieren
     *  - frueher "times" statt "multiplies"
     */
    cout << "Produkt: "
         << accumulate (menge.begin(), menge.end(),
                        1, multiplies<int>())
         << endl;

    /* Elemente ausmultiplizieren, aber mit 0
     *  - frueher "times" statt "multiplies"
     */
    cout << "Produkt mit 0: "
         << accumulate (menge.begin(), menge.end(),
                        0, multiplies<int>())
         << endl;
}
