#include <iostream>
#include <list>
#include <algorithm>
#include <cstdlib>      // fuer rand()
#include "PRINT.h"
using namespace std;

class IntFolge {
  private:
    int wert;
  public:
    IntFolge (int startwert = 0) : wert(startwert) {
    }
    int operator() () {
        return wert++;
    }
};

int main()
{
    list<int> menge;

    /* Folge von 1 bis 6 einfuegen
     */
    generate_n (back_inserter(menge),
                6, IntFolge(1));

    PRINT ("menge: ", menge);

    /* alle Elemente durch Zufallszahlen ersetzen
     */
    generate (menge.begin(), menge.end(),
              rand);

    PRINT ("menge: ", menge);

    /* zweite bis vorletzte Element durch Folge ab 42 ersetzen
     */
    list<int>::iterator pos1, pos2;
    pos1 = menge.begin();
    pos2 = menge.end();
    generate (++pos1, --pos2,
              IntFolge(42));

    PRINT ("menge: ", menge);
}
