#include <iostream>
#include <list>
#include <vector>
#include <algorithm>
using namespace std;

int main()
{
    list<int> liste;
    vector<int> menge;

    /* Elemente 1 bis 9 in die Liste einfuegen
     */
    for (int i=1; i<=9; i++) {
        liste.push_back(i);
    }

    /* gerade Elemente 2 bis 6 in die Menge einfuegen
     */
    for (int i=2; i<=6; i+=2) {
        menge.push_back(i);
    }

    /* beide Mengen ausgeben
     */
    cout << "Liste: ";
    copy (liste.begin(), liste.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
    cout << "Menge: ";
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* pruefen, ob alle Element in der Menge in der
     * Liste enthalten sind
     */
    if (includes (liste.begin(), liste.end(),
                  menge.begin(), menge.end())) {
        cout << "Alle Elemente von Menge sind in Liste enthalten" << endl;
    }
    else {
        cout << "Nicht alle Elemente von Menge sind in Liste enthalten"
             << endl;
    }
}
