#include <bitset>
#include <iostream>
using namespace std;

int main()
{
    // Aufzaehlungstyp fuer Bits
    enum farbe { rot, gelb, gruen, blau, weiss, schwarz, ..., farbenANZ };

    // Bitset fuer alle Farben anlegen
    bitset<farbenANZ> verwendet;

    // Bits fuer zwei Farben setzen
    verwendet.set (rot);
    verwendet.set (blau);

    // Bitset-Daten ausgeben
    cout << "Bitmuster verwendeter Farben: " << verwendet << endl;
    cout << "Anzahl    verwendeter Farben: " << verwendet.count() << endl;
    cout << "Bitmuster nicht verwendeter Farben: " << ~verwendet << endl;

    // falls eine Farbe verwendet wird
    if (verwendet.any()) {
        // fuer alle Farben
        for (farbe f = 0; f < farbenANZ; f++) {
            // falls bestimmte Farbe verwendet wird
            if (verwendet[f]) {
                ...
            }
        }
    }
}
