#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

/* selbst definiertes Funktionsobjekt hoch<>
 */
#include "fohoch.h"

int main()
{
    vector<int> menge;

    // Elemente 1 bis 6 in die Menge einfuegen
    for (int i=1; i<=6; i++) {
        menge.push_back(i);
    }

    /* 3 hoch alle Elemente ausgeben
     */
    transform (menge.begin(), menge.end(),       // Quellbereich
               ostream_iterator<int>(cout, " "), // Zielbereich
               bind1st(hoch<int>(),3));          // Operation
    cout << endl;

    /* alle Elemente hoch 3 ausgeben
     */
    transform (menge.begin(), menge.end(),       // Quellbereich
               ostream_iterator<int>(cout, " "), // Zielbereich
               bind2nd(hoch<int>(),3));          // Operation
    cout << endl;
}
